/* cat files into one. */

#include "myFilter.h"

long	GetSizeOfFiles( long, FSSpec *);
long	GetSpaceAvailable( short);
OSErr	DoMyError( short, short, OSErr);
char 	*pStrcpy(char *,char *); /* to copy strings for the dialogs */

char				*buffer;
FTBlockPtr			gTheBlock;
callBackPtr			callBack;

/********************************** Main **********************/

OSErr		main( theBlock)
FTBlockPtr	theBlock;
{
	FSSpec				*inList, *outList;
	long				inCount, *outCount;
	short				i, j, srcRefNum, dstRefNum, progress;
	long				count = 512, totalSize, diskSpace;
	OSErr				err;
	StandardFileReply	reply;

	gTheBlock = theBlock;
	callBack = theBlock->callBackProc;
	inCount = theBlock->inFileCount;
	inList = theBlock->inFileList;
	outCount = theBlock->outFileCount;
	outList = theBlock->outFileList;
	
	totalSize = GetSizeOfFiles( inCount, inList);
	buffer = (char *)NewPtrClear( 512);

	StandardPutFile("\p", "\p", &reply );
	if ( !reply.sfGood ) /* User hit cancel */
	{
		DisposePtr((Ptr)buffer);
		return -1;
	}
	diskSpace = GetSpaceAvailable(reply.sfFile.vRefNum);
	if( diskSpace - totalSize < 0) 
	{
		pStrcpy((char *)theBlock->string0, (char *)"\pNot Eneough Space on Disk");
		theBlock->message = DO_ALERT_STRING;
		(*callBack)( theBlock);			/* Handle error string */
		return -1;
	}
	err = FSpDelete( &reply.sfFile);
	err = FSpCreate( &reply.sfFile, 'NISI', 'TEXT', -1);
	if( err != noErr) return err;
	err = FSpOpenDF( &reply.sfFile, fsWrPerm, &dstRefNum);
	if( err != noErr) return err;
	
	theBlock->progress = 0;
	theBlock->message = DO_PROGRESS;
	(*callBack)( theBlock);			/* Display the Progress Window */
	
	for( i = 0; i < inCount; ++i)			/* index thru the files */
	{
		
		theBlock->progress = (i + 1) * (100 / inCount);
		pStrcpy((char *)theBlock->string0, (char *)"\pCat Filter");
		pStrcpy((char *)theBlock->string1, (char *)inList[i].name);
		theBlock->message = DO_PROGRESS;
		(*callBack)( theBlock);			/* Display the Progress Window */

		err = FSpOpenDF( &inList[i], fsCurPerm, &srcRefNum);
		if( err != noErr)  return DoMyError( srcRefNum, dstRefNum, err);

		count = 512;		
		while ( ( err = FSRead( srcRefNum, &count, buffer) ) == noErr )
		{
			err = FSWrite( dstRefNum, &count, buffer);
			if( err != noErr)  return DoMyError( srcRefNum, dstRefNum, err);
			
			theBlock->message = FILTER_HANDLE_EVENT;
			(*callBack)( theBlock);		/* if using the Progress window, make sure user didn't hit Stop */
			if( theBlock->message == -1) return DoMyError( srcRefNum, dstRefNum, -1);	/* user has hit the stop button in the Progress window */
		}
		if( err == eofErr) err = FSWrite( dstRefNum, &count, buffer);
		else if( err != noErr) return DoMyError( srcRefNum, dstRefNum, err);
		FSClose( srcRefNum);
	}
	FSClose( dstRefNum);

	theBlock->progress = 101;
	theBlock->message = DO_PROGRESS;
	(*callBack)( theBlock);			/* Dispose the Progress Window */

	outList[0].vRefNum = reply.sfFile.vRefNum;
	outList[0].parID = reply.sfFile.parID;
	for( i = 0; i <= reply.sfFile.name[0]; ++i) outList[0].name[i] = reply.sfFile.name[i];
	*outCount = 1;

	DisposPtr( (Ptr)buffer );
	return err;
}

/************************************ GetSizeOfFiles **************************/

long	GetSizeOfFiles( fileCount, fileArray)
long	fileCount;
FSSpec	*fileArray;
{
	short	i, refNum;
	OSErr	err;
	long	length = 0, totalLength = 0;
	
	for( i = 0; i < fileCount; ++i)			/* index thru the files */
	{
		err = FSpOpenDF( &fileArray[i], fsCurPerm, &refNum);
		GetEOF( refNum, &length);
		FSClose( refNum);
		totalLength += length;
	}
	return totalLength;
}

/************************************ GetSpaceAvailable **************************/

long	GetSpaceAvailable( vRefNum)
short	vRefNum;
{
	long	freeBytes;
	short	vRef;
	
	GetVInfo( vRefNum, 0L, &vRef, &freeBytes);
	return freeBytes;
}

/************************************ DoMyError **************************/

OSErr	DoMyError( srcRefNum, dstRefNum, err)
short	srcRefNum, dstRefNum;
OSErr	err;
{
	gTheBlock->progress = 101;
	gTheBlock->message = DO_PROGRESS;
	(*callBack)( gTheBlock);			/* Dispose the Progress Window */
	
	FSClose( srcRefNum);
	FSClose( dstRefNum);
	DisposPtr((Ptr)buffer);
	return err;
}

/********************************** pStrcpy *************************************/

char *pStrcpy(s,t)
	char *s, *t;
{
	short	tLen;

	for (tLen = *t + 1; tLen--; s[tLen] = t[tLen]);
	return (s);
}

