/* fileUtils.c */

#include			"fileUtils.h"
#include			"myString.h"
#include			"filter.h"
#include			"windowUtils.h"

/****************** Globals *****/

extern ListHandle	gFileList, gFilterList;
extern Boolean		gDone;
extern funcHdl		*filters;						/* Filters pointer table */
FSSpec				*gInFileArray, *gOutFileArray;	/* FSSpec pointer table */

/********************************** FileFilterInit **********************/

void	FileFilterInit()
{
	gInFileArray = 0L;
	gInFileArray = (FSSpec*) NewPtrClear( MAXFILES * sizeof( FSSpec));
	if( gInFileArray == 0L)
		gDone == TRUE;

	gOutFileArray = 0L;
	gOutFileArray = (FSSpec*) NewPtrClear( MAXFILES * sizeof( FSSpec));
	if( gOutFileArray == 0L)
		gDone == TRUE;

	filters = 0L;
	filters = (funcHdl*) NewPtrClear( MAXFILTERS * sizeof( funcHdl));
	if( filters == 0L)
		gDone == TRUE;
}

/********************************** SetupFileArray ***********************/

void	SetupFileArray()
{
	short	i, specLen;
	FSSpec	theSpec;
	Point	cell;
	
	SetPt( &cell, 1, 0);
	for( i = 0; i < (**gFileList).dataBounds.bottom; ++i)
	{
		specLen = sizeof(FSSpec);
		cell.v = i;
		LGetCell( &theSpec, &specLen, cell, gFileList);	/* get the FSSpec */
		gInFileArray[i].vRefNum = theSpec.vRefNum;
		pStrcpy( (char *)gInFileArray[i].name, (char *)theSpec.name);
		gInFileArray[i].parID = theSpec.parID;
	}
}

/********************************** FileFilterKill **********************/

void	FileFilterKill()
{
	if( gInFileArray != 0L) 
	{
		DisposPtr((Ptr) gInFileArray);
		gInFileArray = 0L;
	}
	if( gInFileArray != 0L) 
	{
		DisposPtr((Ptr) filters);
		filters = 0L;
	}
}

/********************************** MyOpenFile **********************/

Boolean		MyOpenFile( myFSS)
FSSpec		*myFSS;
{
	Point	cell;
	char	line[63];
	short	i, fRef;
	OSErr	err;
	
	if( (err = FSpOpenDF( myFSS, fsRdPerm, &fRef) ) != 0) /* found a folder; no doubt there is a better way to do this */
		MyOpenFolder( myFSS);
	else
	{	
		FSClose( fRef);
		if( CheckTheType( myFSS))	/* check for TEXT or filter type */
		{
			AddLineToList( gFileList, myFSS->name);
			AddFSSpecToFileList( myFSS);
		}
		else	/* must be a filter */
		{
			AddSingleFilter( gFilterList, myFSS);
			AddLineToList( gFilterList, myFSS->name);
			AddFilterIcon( myFSS);
		}
	}
	return 0;
}

/********************************** MyOpenFolder **********************/
 void			MyOpenFolder( myFSS)
 FSSpec			*myFSS;
 {
 	long		dirID;
	short		index;
	HFileInfo	myCPB;
	OSErr		myErr = noErr;
	FSSpec		newFSS;
	
	myCPB.ioVRefNum = 0;
	myCPB.ioFDirIndex = 0;
	myCPB.ioNamePtr = (StringPtr)&myFSS->name;
	myCPB.ioDirID = myFSS->parID;
	myErr = PBGetCatInfo((CInfoPBPtr) &myCPB, FALSE);
	dirID = myCPB.ioDirID;
	if( myErr != noErr)
	{
		ParamText( "\pStuffup opening folder", "\p", "\p", "\p" );
		StopAlert( 400, 0L);
		return;
	}
	myCPB.ioNamePtr = (StringPtr) NewPtrClear(40L);
	index = 1;
	myErr = noErr;
	while( myErr == noErr)
	{
		myCPB.ioFDirIndex = index;
		myCPB.ioNamePtr[0] = 0;
		myCPB.ioDirID = dirID;
		myErr = PBGetCatInfo((CInfoPBPtr) &myCPB, FALSE);
		if( myErr == noErr) 
		{
			if( myCPB.ioFlFndrInfo.fdType == 'TEXT' )	/* file */
			{
				FSMakeFSSpec( 0L, dirID, myCPB.ioNamePtr, &newFSS);
				AddLineToList( gFileList, myCPB.ioNamePtr);
				AddFSSpecToFileList(&newFSS);
			}
			else if( myCPB.ioFlFndrInfo.fdType == 'FIL1'
					|| myCPB.ioFlFndrInfo.fdType == 'FIL2'
					|| myCPB.ioFlFndrInfo.fdType == 'FIL3'
					|| myCPB.ioFlFndrInfo.fdType == 'FIL4')
		{
				FSMakeFSSpec( 0L, dirID, myCPB.ioNamePtr, &newFSS);
				AddSingleFilter( gFilterList, &newFSS);
				AddLineToList( gFilterList, myCPB.ioNamePtr);
				AddFilterIcon( &newFSS);
			}
		}
		index += 1;
	}
	DisposePtr( (Ptr) myCPB.ioNamePtr);
}

/********************************** CheckTheType *************************/

Boolean		CheckTheType( myFSS)
FSSpec		*myFSS;
{
	FInfo	fileInfo;
	
	FSpGetFInfo( myFSS, &fileInfo);
	if( fileInfo.fdType == 'TEXT')	/* its a text file */
		return true;
	return false;
}
	
/********************************** AddFilterIcon *************************/

void		AddFilterIcon( myFSS)
FSSpec		*myFSS;
{
	FInfo	fileInfo;
	short	filterNum = 1, bottom;
	Point	cell;
		
	
	FSpGetFInfo( myFSS, &fileInfo);
	if( fileInfo.fdType == 'FIL1') filterNum = 1;
	else if( fileInfo.fdType == 'FIL2') filterNum = 2;
	else if( fileInfo.fdType == 'FIL3') filterNum = 3;
	else if( fileInfo.fdType == 'FIL4') filterNum = 4;
	
	bottom = (**gFilterList).dataBounds.bottom -1;
	if( bottom < 0) bottom = 0;
	SetPt( &cell, 1, bottom);
	LSetCell( &filterNum, sizeof(short), cell, gFilterList);	/* set the FSSpec */
}

/*************************************** AddFSSpecToFileList ************************/

void		AddFSSpecToFileList(myFSS)
FSSpec		*myFSS;
{
	short	bottom;
	Point	cell;
		
	bottom = (**gFileList).dataBounds.bottom -1;
	if( bottom < 0) bottom = 0;
	SetPt( &cell, 1, bottom);
	LSetCell( myFSS, sizeof(FSSpec), cell, gFileList);	/* set the FSSpec */
}

