/* menu.c */

#include				"main.h"
#include				"menus.h"
#include				"fileUtils.h"

/***************defines */

#define APPLE_MENU_ID		400
#define FILE_MENU_ID		401
#define EDIT_MENU_ID		402
#define ABOUT_ITEM			1
#define OPEN_ITEM			1
#define QUIT_ITEM			2

/*************** globals *****/

MenuHandle				gAppleMenu, gFileMenu, gEditMenu;

extern	WindowPtr		gFilesWindow;
extern	Boolean			gDone;

/************************ MenuBarInit *****************************/

void		MenuBarInit( void )
{
	Handle	myMenuBar;
	
	myMenuBar = GetNewMBar(400);
	SetMenuBar(myMenuBar);
	
	gAppleMenu = GetMHandle(APPLE_MENU_ID);
	AddResMenu(gAppleMenu, 'DRVR');

	gFileMenu = GetMHandle(FILE_MENU_ID);

	gEditMenu = GetMHandle(EDIT_MENU_ID);

	DrawMenuBar();
}

/************************ HandleMenuChoice ***********************/

void		HandleMenuChoice(menuChoice)
long		menuChoice;
{
	short	theMenu;
	short	theItem;
	
	if (menuChoice !=0)
	{
		theMenu = HiWord(menuChoice);
		theItem = LoWord(menuChoice);
		switch (theMenu)
		{
			case APPLE_MENU_ID :
				HandleAppleChoice(theItem);
				break;
	
			case FILE_MENU_ID :
				HandleFileChoice(theItem);
				break;
	
			case EDIT_MENU_ID :
				HandleEditChoice(theItem);
				break;
		}
		HiliteMenu(0);
	}
}

/********************* HandleAppleChoice *********************/

void	HandleAppleChoice(theItem)
short		theItem;
{
	Str255		accName;
	short		accNumber;
	short		itemNumber;
	
	switch (theItem)
	{
		case ABOUT_ITEM :
			Alert( 401, 0L);
			break;

		default :
			GetItem(gAppleMenu, theItem, accName);
			accNumber = OpenDeskAcc( accName );
			break;
	}
}

/********************* HandleFileChoice *********************/

void		HandleFileChoice(theItem)
short		theItem;
{	
	short	markChar;
	
	switch (theItem)
	{
		case OPEN_ITEM :
			ShowWindow( gFilesWindow);
			SelectWindow( gFilesWindow );
			DoOpenChoice();
			break;
		
		case QUIT_ITEM :
			gDone = TRUE;
			break;
	}
}

/*************************** HandleEditChoice ************************/

void	HandleEditChoice( theItem )
short	theItem;
{
	;	/* for the inactive Edit menu */
}

