#include "FilterTop.h"
#include <Types.h>
#include <Processes.h>
#include <SetUpA4.h>

Boolean FindAProcess(OSType signature, ProcessSerialNumber *process,
					ProcessInfoRec *infoRec, FSSpecPtr aFSSpecPtr)
{
	static Boolean	result;
	
	result = false;
	process->highLongOfPSN = 0;
	process->lowLongOfPSN = kNoProcess;
	
	infoRec->processInfoLength = sizeof(ProcessInfoRec);
	infoRec->processName = (StringPtr) NewPtr(32);
	infoRec->processAppSpec = aFSSpecPtr;
	
	while(GetNextProcess(process) == noErr)
	{
		if(GetProcessInformation(process, infoRec) == noErr)
		{
			if((infoRec->processType == (long) 'APPL') &&
			   (infoRec->processSignature == signature))
			{
				result = true;
				DisposPtr((Ptr) infoRec->processName);
				return result;
			}
		}
	}
	return result;
}

pascal OSErr main(OSType gestaltSelector, long *gestaltResponse)
{
	static ProcessSerialNumber		filterTopProcess;
	static ProcessInfoRec			filterTopProcessInfoRec;
	static FSSpecPtr				filterTopFSSpecPtr;
	static Boolean					filterTopRunning;

	RememberA0();
	SetUpA4();
	
	filterTopRunning = FindAProcess('fTOP', &filterTopProcess,
									&filterTopProcessInfoRec, filterTopFSSpecPtr); 
	
	if(filterTopRunning)
	{
		*gestaltResponse = 4;	/* bits 0 through 3 are set */
		RestoreA4();
		return 0;
	}
	else
	{
		*gestaltResponse = 2; 
		RestoreA4();
		return -1;				/* FilterTop not running! */
	}
}

