/* FilterTop 0.1 -- Partial user-interface code */

#include "defs.h"
#include "Prototypes.h"
#include "Globals.h"
#include <Balloons.h>

main()
{
	ToolBoxInit();
	Action();
	WindowSetup();
	RectSetup();
	MenuSetup();
	MiscSetup();
	DialogSetup();
	MainEventLoop();
}

void WindowSetup()
{
	ftWindow = GetNewWindow(DEFAULT_ID, nil, (Ptr) -1L);
	SetPort(ftWindow);
	ShowWindow(ftWindow);
	SelectWindow(ftWindow);
}

RectSetup()
{
    boundsRect = (*GetGrayRgn()) -> rgnBBox;
    
 	sizeRect = boundsRect;
	sizeRect.top = 50;
	sizeRect.left = 150;
	sizeRect.bottom -= 40;
}

MenuSetup()
{
	Handle		ftMBar;
	OSErr		menuErr;
	int			index;
	Str255		helpString;
	
	ftMBar = GetNewMBar(DEFAULT_ID);
	SetMenuBar(ftMBar);
	
	appleMenu = GetMHandle(APPLE_MENU);
	AddResMenu(appleMenu, 'DRVR');
	
	prefsSubmenu = GetMenu(PREFS_SUBMENU);
	InsertMenu(prefsSubmenu, hierMenu);
	
	menuErr = HMGetHelpMenuHandle(&helpMenu);
	if(menuErr == noErr)
		if(helpMenu != nil)
		{
			for(index = 1; index < FT_HM_ITEMS+1; ++index)
			{
				GetIndString(helpString, HELP_BASE_ID, index);
				AppendMenu(helpMenu, helpString);
			}
		}
	DrawMenuBar();
}

MiscSetup()
{

}

pascal void ThickOutline(DialogPtr myDialog, int theItem)
{
	int			itemKind;
	Handle		itemHandle;
	Rect		itemRect;
	PenState	myPenState;
	GrafPtr		oldPort;
	
	GetPort(&oldPort);
	SetPort(myDialog);
	
	GetDItem(myDialog, CANCEL, &itemKind, &itemHandle, &itemRect);
	GetPenState(&myPenState);
	PenSize(3, 3);
	InsetRect(&itemRect, -4, -4);
	FrameRoundRect(&itemRect, 16, 16);
	SetPenState(&myPenState);
	
	SetPort(oldPort);
}

DialogSetup()
{
	int		itemKind;
	Handle	itemHandle;
	Rect	itemRect;

	generalPrefsDialog  = GetNewDialog(GENERAL_PREFS_ID, nil, (Ptr) -1L);
	SetItems(generalPrefsDialog, set, SHOW_PROGRESS_WINDOW, DELETE_ORIGINAL);
	notificationPrefsDialog  = GetNewDialog(NOTIFICATION_PREFS_ID, nil, (Ptr) -1L);
	SetItems(notificationPrefsDialog, set, NOP_NOTHING, NOP_NOTHING);
	SetItems(notificationPrefsDialog, set, DONE_NOTHING, DONE_NOTHING);
	fileCreationPrefsDialog  = GetNewDialog(FILE_CREATION_PREFS_ID, nil, (Ptr) -1L);
	SetItems(fileCreationPrefsDialog, set, ASK_NEW_NAME, ASK_NEW_NAME);
	progressDialog = GetNewDialog(PROGRESS_DIALOG_ID, nil, (Ptr) -1L);
	processPriorityDialog = GetNewDialog(PROCESS_PRIORITY_ID, nil, (Ptr) -1L);
	
	hmFTHelpDialog = GetNewDialog(FT_HELP_DLG_ID, nil, (Ptr) -1L);
	hmBuildSuperfiltersDialog = GetNewDialog(BUILD_SUPERFILTERS_DLG_ID, nil, (Ptr) -1L);
	hmSettingFilterOptionsDialog = GetNewDialog(SETTING_FILTER_OPTS_DLG_ID, nil, (Ptr) -1L);
	hmShortcutsDialog = GetNewDialog(SHORTCUTS_DLG_ID, nil, (Ptr) -1L);
	hmTopSoftDialog = GetNewDialog(TOPSOFT_DLG_ID, nil, (Ptr) -1L);
	
	GetDItem(generalPrefsDialog, 6, &itemKind, &itemHandle, &itemRect);
	SetDItem(generalPrefsDialog, 6, itemKind, (Handle) ThickOutline, &itemRect);
	GetDItem(notificationPrefsDialog, 13, &itemKind, &itemHandle, &itemRect);
	SetDItem(notificationPrefsDialog, 13, itemKind, (Handle) ThickOutline, &itemRect);
	GetDItem(fileCreationPrefsDialog, 9, &itemKind, &itemHandle, &itemRect);
	SetDItem(fileCreationPrefsDialog, 9, itemKind, (Handle) ThickOutline, &itemRect);
	GetDItem(processPriorityDialog, 7, &itemKind, &itemHandle, &itemRect);
	SetDItem(processPriorityDialog, 7, itemKind, (Handle) ThickOutline, &itemRect);
}

SetItems(DialogPtr thisDialog, int value, int startItem, int endItem)
{
	int		itemKind, count;
	Handle	itemHandle;
	Rect	itemRect;
	
	for(count = startItem; count < endItem+1; count++)
	{
		GetDItem(thisDialog, count, &itemKind, &itemHandle, &itemRect);
		SetCtlValue(itemHandle, value);
	}
}

ToolBoxInit()
{
	InitGraf(&thePort);
	InitFonts();
	FlushEvents(everyEvent, 0);
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs((ProcPtr) nil);
	InitCursor();
}


MainEventLoop()
{
	EventRecord	myEvent;
	int			eventType;
	Boolean		gotEvent, isDialogEvent;
	Boolean		validHit;
	DialogPtr	hitDialog;
	int			itemHit;

	while(done==false)
	{
		gotEvent = WaitNextEvent(everyEvent, &myEvent, sleepTicks, currentRegion);
 		isDialogEvent = IsDialogEvent(&myEvent);
		
		if(isDialogEvent == true)
		{
			validHit = DialogSelect(&myEvent, &hitDialog, &itemHit);
			if(validHit == true)
				HandleModelessHit(hitDialog, itemHit);
		}
		
		if(gotEvent == true)
	 	{
	 		 		eventType = myEvent.what;
	 	
	 		switch(eventType)
	 		{
	 			case	keyDown:
	 			case	autoKey:
	 			
	 					HandleKeyDown(myEvent.message, myEvent.modifiers);
	 					break;
	 					
	 			case	mouseDown:
	 			
	 					HandleClick(&myEvent);
	 					break;
	 					
	 			case	updateEvt:
	 			
	 					HandleUpdate((WindowPtr) myEvent.message);
	 					break;
	 					
	 			case	activateEvt:
	 			
	 					HandleActivate((WindowPtr) myEvent.message);
	 					break;
	 					
	 			case	osEvt:
	 			
	 					HandleOSEvent(&myEvent);
	 					break;
	 					
/*	 			case	kHighLevelEvent:
	 			
	 					HandleHighLevelEvent();
	 					break;
	 		
*/
	 			case	nullEvent:
	 			
	 					HandleNull();
	 					break;
	 					
	 		}
	 	}
	}
}

HandleModelessHit(DialogPtr thisDialog, int itemHit)
{
	int		itemKind;
	Handle	itemHandle;
	Rect	itemRect;

	if((itemHit == SAVE) || (itemHit == CANCEL))
	{
		HideWindow(thisDialog);
		return;
	}

	if(thisDialog == generalPrefsDialog)
	{	
		GetDItem(thisDialog, itemHit, &itemKind, &itemHandle, &itemRect);
		SetCtlValue(itemHandle, !GetCtlValue(itemHandle));
	} 
	else if(thisDialog == notificationPrefsDialog)
	{
		switch(itemHit)
		{
			case	NOP_NOTHING:
			case	NOP_BEEP:
			case	NOP_ICON_FLASH:
			case	NOP_ALERT:

					GetDItem(thisDialog, notificationNotChoice, &itemKind, &itemHandle, &itemRect);
					SetCtlValue(itemHandle, clear);
				
					GetDItem(thisDialog, itemHit, &itemKind, &itemHandle, &itemRect);
					SetCtlValue(itemHandle, !GetCtlValue(itemHandle));
					notificationNotChoice = itemHit;
					
					break;
					
			case	DONE_NOTHING:
			case	DONE_BEEP:
			case	DONE_ICON_FLASH:
			case	DONE_ALERT:

					GetDItem(thisDialog, notificationDoneChoice, &itemKind, &itemHandle, &itemRect);
					SetCtlValue(itemHandle, clear);
				
					GetDItem(thisDialog, itemHit, &itemKind, &itemHandle, &itemRect);
					SetCtlValue(itemHandle, !GetCtlValue(itemHandle));
					notificationDoneChoice = itemHit;
					
					break;
		}						
	}
	else if(thisDialog == fileCreationPrefsDialog)
	{
		GetDItem(thisDialog, fileCreationChoice, &itemKind, &itemHandle, &itemRect);
		SetCtlValue(itemHandle, clear);
		
		GetDItem(thisDialog, itemHit, &itemKind, &itemHandle, &itemRect);
		SetCtlValue(itemHandle, set);
		fileCreationChoice = itemHit;
	}
		 
}

HandleKeyDown(long key, int modifiers)
{
	if(modifiers & cmdKey)
		HandleMenu(MenuKey(key));
}	

HandleMenu(long menuCode)
{
	int		thisMenu, thisItem;
	
	thisMenu = HiWord(menuCode);
	thisItem = LoWord(menuCode);
	
	switch(thisMenu)
	{
		case	APPLE_MENU:
		
				HandleApple(thisItem);
				break;
				
		case	FILE_MENU:
		
				HandleFile(thisItem);
				break;
			
		case	EDIT_MENU:
		
				HandleEdit(thisItem);
				break;
				
		case	FILTERS_MENU:
		
				HandleFilters(thisItem);
				break;
				
		case	PREFS_SUBMENU:
		
				HandlePrefs(thisItem);
				break;
				
		case	WINDOW_MENU:
		
				HandleWindow(thisItem);
				break;
				
		case	kHMHelpMenuID:
		
				HandleHelp(thisItem);
				break;
	}
	HiliteMenu(0);
}
 	
HandleApple(int thisItem)
{
	Str255		daName;
	
	switch(thisItem)
	{
		case	ABOUT_FILTERTOP:
		
				NoteAlert(DEFAULT_ID, nil);
				break;
				
		case	SET_PROCESS_PRIORITY:
		
				ShowDialog(processPriorityDialog);
				break;
				
		default:
				
				GetItem(appleMenu, thisItem, daName);
				OpenDeskAcc(daName);
				break;
	}
	HiliteMenu(0);
}

SetPriority()
{

}

HandleFile(int thisItem)
{
	switch(thisItem)
	{
		case	NEW_SUPERFILTER:
		
				HandleNewSuperfilter();
				break;
				
		case	OPEN:
		
				HandleOpen();
				break;
				
		case	CLOSE:
		
				HandleClose();
				break;
				
		case	SAVE_ITEM:
		case	SAVE_AS:
		
				HandleSave();
				break;
				
		case	REVERT:
		
				HandleRevert();
				break;
				
		case	TRANSFORM_FILE:
		
				HandleTransform();
				break;
				
		case	GET_INFO:
		
				HandleGetInfo();
				break;
				
		case	PUBLISH:
		
				HandlePublish();
				break;
				
		case	SUBSCRIBE:
		
				HandleSubscribe();
				break;
				
		case	PAGE_SETUP:
		
				HandlePageSetup();
				break;
				
		case	PRINT:
		
				HandlePrint();
				break;
				
		case	QUIT:
		
				HandleQuit();
				break;
	}	
	HiliteMenu(0);	
}

HandleNewSuperfilter()
{

}

HandleOpen()
{

}

HandleClose()
{

}

HandleSave()
{

}

HandleRevert()
{

}

HandleTransform()
{

}

HandleGetInfo()
{

}

HandlePublish()
{

}

HandleSubscribe()
{

}

HandlePageSetup()
{

}

HandlePrint()
{

}

HandleQuit()
{
	HiliteMenu(FILE_MENU);
	done = true;
	HiliteMenu(0);
}

HandleEdit(int thisItem)
{
	switch(thisItem)
	{
	
		case	UNDO:
		
				HandleUndo();
				break;
				
		case	CUT:
		
				HandleCut();
				break;
				
		case	COPY:
		
				HandleCopy();
				break;
				
		case	PASTE:
		
				HandlePaste();
				break;
				
		case	CLEAR:
		
				HandleClear();
				break;
				
		case	SELECT_ALL:
		
				HandleSelectAll();
				break;
				
		case	ATTACH_FOLDER:
		
				HandleAttachFolder();
				break;
	}
	HiliteMenu(0);
}
 
HandleUndo()
{

}

HandleCut()
{

}

HandleCopy()
{

}

HandlePaste()
{

}

HandleClear()
{

}

HandleSelectAll()
{

}

HandleAttachFolder()
{

}
 
HandleFilters(int thisItem)
{
	switch(thisItem)
	{
		case	SET_DEFAULT_OPTIONS:
		
				HandleSetDefaultOptions();
				break;
				
		case	REDIRECT_OUTPUT:
		
				HandleRedirectOutput();
				break;
				
		case	INTELLIGENCE:
		
				HandleIntelligence();
				break;
	}
	HiliteMenu(0);
}

HandleSetDefaultOptions()
{

}

HandleRedirectOutput()
{

}

HandleIntelligence()
{

}

HandlePrefs(int thisItem)
{
	switch(thisItem)
	{
		case	GENERAL:
		
				ShowDialog(generalPrefsDialog);
				break;
				
		case	NOTIFICATION:
		
				ShowDialog(notificationPrefsDialog);
				break;
				
		case	FILE_CREATION:
		
				ShowDialog(fileCreationPrefsDialog);
				break;
	}
	HiliteMenu(0);
}

ShowDialog(GrafPtr myDialog)
{
	ShowWindow(myDialog);
	SelectWindow(myDialog);
}
	
HandleWindow(int thisItem)
{
	/* just select the window chosen */
}

HandleHelp(int thisItem)
{
	switch(thisItem)
	{
		case	FILTERTOP_HELP:
		
				ShowDialog(hmFTHelpDialog);
				break;
				
		case	BUILDING_SUPERFILTERS:
		
				ShowDialog(hmBuildSuperfiltersDialog);
				break;
				
		case	SETTING_FILTER_OPTIONS:
		
				ShowDialog(hmSettingFilterOptionsDialog);
				break;
				
		case	SHORTCUTS:
		
				ShowDialog(hmShortcutsDialog);
				break;
				
		case	ABOUT_TOPSOFT:
		
				ShowDialog(hmTopSoftDialog);
				break;
	}
}
 
HandleClick(EventRecord *myEvent)
{
	int			where;
	long		menuCode;
	WindowPtr	clickedWindow;
	
	where = FindWindow(myEvent->where, &clickedWindow);
	
	switch(where)
	{
		case	inMenuBar:
		
				menuCode = MenuSelect(myEvent->where);
				HandleMenu(menuCode);
				break;
				
		case	inSysWindow:
		
				SystemClick(myEvent, clickedWindow);
				break;
				
		case	inContent:
		
				SelectWindow(clickedWindow);
				break;
				
		case	inDrag:
		
				SelectWindow(clickedWindow);    
				DragWindow(clickedWindow, myEvent->where, &boundsRect);
				break;
				
		case	inGoAway:
		
				HandleGoAway(clickedWindow, where, myEvent->where);
				break;
				
		case	inGrow:
		
				HandleGrow(clickedWindow, myEvent->where);
				break;
				
		case	inZoomIn:
		case	inZoomOut:
		
				HandleZoom(clickedWindow, where, myEvent->where);
				break;
	}
}

HandleZoom(WindowPtr clickedWindow, int partCode, Point downHere)
{
	if(TrackBox(clickedWindow, downHere, partCode))
	{
		ZoomWindow(clickedWindow, partCode, true);
	}
}

HandleGoAway(WindowPtr clickedWindow, int partCode, Point downHere)
{
	Boolean		clickedBox;
	
	clickedBox = TrackBox(clickedWindow, downHere, partCode);
		if((clickedBox == true) && (clickedWindow == ftWindow))
			done = true;
	else
		HideWindow(clickedWindow);
}

HandleGrow(WindowPtr thisWindow, Point clickedHere)
{
	long	location;
	int		h, v;
	
	location = GrowWindow(thisWindow, clickedHere, &sizeRect);
	h = LoWord(location);
	v = HiWord(location);
	SizeWindow(thisWindow, h, v, false);
	InvalRect(&thisWindow->portRect);
}

HandleUpdate(WindowPtr updateWindow)
{
	InvalRect(&updateWindow->portRect);

	BeginUpdate(updateWindow);
	EraseRect(&updateWindow->portRect);
	if(updateWindow == ftWindow)
		DrawGrowIcon(updateWindow);
	EndUpdate(updateWindow);
}

HandleActivate(WindowPtr activateWindow)
{
	if(activateWindow == ftWindow)
		DrawGrowIcon(activateWindow);
}

HandleOSEvent(EventRecord *myEvent)
{

}

HandleHighLevelEvent()
{

}

HandleNull()
{

}	 	
	 	
 	
 	
 	
 	
 	
 	
 	
 	
 	
 	
 	