/*
================================================================================
	
	sicnLDEF.main.c
	
	This is a sample program to test the bahivor of the LDEF+sicn code.
	
	Procdure:
		Open up a dialog box, set up a new list, display it, modal it, and then
		kill it. Pretty simple.
		
	History
		1/27/92	DNY	Original TC 5.0.2
		1/28/92	DNY	Cleaned up and readied for release

================================================================================
*/

/*---- Prototypes -----*/
pascal Boolean dlogFilter(DialogPtr theDialog, EventRecord *theEvent,short *itemHit);

main()
{
	SetUpMac();
	DoDialog();
	ExitToShell();
}

SetUpMac()
{
	InitGraf(&thePort);
	InitFonts();
	FlushEvents(everyEvent, 0);
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(0L);
	InitCursor();
	MaxApplZone();
}

DoDialog()
{
typedef	struct celldata {
			int		index;
			char	str[80];
		};
struct celldata	theData;
DialogPtr	theD;
int			itemHit,itemType;
Handle		itemHandle;
Point		pCellSize,theCell;
Rect		itemRect,rView,rBounds;
ListHandle	theList;

	theD = GetNewDialog(128,0L,(WindowPtr) -1L);
	HideWindow(theD);					// Hide window to set up list
	// Set up the list
	pCellSize.h = pCellSize.v = 0;		// let list manager auto-config cell size
	GetDItem(theD,2,&itemType,&itemHandle,&rView);	// get list's view rec from dlog
	rView.right -= 14;					// room for right scroll bar
	rView.top += 1;						// room for top indent
	rView.left += 1;					// room for left indent
	rView.bottom -= 1;					// room for bottom indent
	SetRect(&rBounds, 0, 0, 1, 3);		// set list size, 1 wide, 3 deep
	theList = LNew ( &rView, &rBounds, pCellSize, 1000, theD,
					 1, 0, 0, 1 );
	// Add data to the list using the celldata structure
	theData.index = 0;
	theData.str[0] = 1;
	theData.str[1] = 'H';				// this should be a cpystr or something...
	theData.str[2] = 'i';
	theData.str[3] = '!';
	for (theCell.h = theCell.v = 0; theCell.v < 3; theCell.v++)
	{
		LSetCell(&theData, 8, theCell, theList );
		theData.index++;
		theData.str[0] = theData.str[0]+1;
	}

	// Note: Uncomment the following to cause the LDEF to use a cutsom
	//		SICN handle. This allows user configuring of the SICN list.
	// (**theList).userHandle = GetResource('SICN', 128);
	SetWRefCon ( theD, (long)theList );	// put list handle into dlog refcon for filter
	ShowWindow(theD);
	SetPort(theD);						// the list will be drawn with the current
	TextFont(3);						// grafPort's settings
	TextSize(9);
	TextFace ( 1 );
	GetDItem(theD,2,&itemType,&itemHandle,&rView);
	FrameRect(&rView);					// show the list rectangle
	LUpdate ( (*theList)->port->visRgn,theList );
	GetDItem(theD,1,&itemType,&itemHandle,&itemRect);
	PenSize(3,3);
	InsetRect(&itemRect,-4,-4);
	FrameRoundRect(&itemRect,16,16);	// frame default button

	// Modal the dlog, wait for default button or list double click
	do { ModalDialog(&dlogFilter, &itemHit); } while (itemHit != 1);
	
	LDispose ( theList );				// kill list first
	DisposeDialog(theD);				// kill dlog
}

/*======================= dlogFilter =======================*/
/*------------------------------------------------------------
A dialog filter customized to handle one list in the dialog.
The dialog's window refcon is used to hold the list handle;
this prevents use of a global var. I got this thing against
globals...
------------------------------------------------------------*/
pascal Boolean dlogFilter(theDialog, theEvent, itemHit)
DialogPtr theDialog;
EventRecord *theEvent;
short *itemHit;
{
char 			theChar;
short			iType;
int				iCtlPart;
long			theRefCon;
ControlHandle	theControl,iHandle;
Rect			iRect;
ListHandle		theList;
	
	switch (theEvent->what) 
	{
		case keyDown:
			theChar = theEvent->message & charCodeMask;
			if ((theChar==0x03) || (theChar==0x0D)) 
			{
				*itemHit = 1;
				return true;
			}
			break;
			
		case mouseDown:
			GlobalToLocal(&theEvent->where);
			theList = (ListHandle) GetWRefCon ( theDialog );
			if (LClick( theEvent->where, theEvent->modifiers, theList ))
			{
				*itemHit = 1;
				return true;
			}
			if (PtInRect( theEvent->where, &(*theList)->rView ))
				return true;
			iCtlPart = FindControl ( theEvent->where, (WindowPtr)theDialog, &theControl );
			if (iCtlPart)
			{
				GetDItem ( theDialog, 1, &iType, &iHandle, &iRect );
				if (iHandle==theControl)
					if (TrackControl(theControl, theEvent->where, 0L) != 0)
					{
						*itemHit = 1;
						return true;
					}
			}
			break;
	}
	return false;

}